package fr.cnam.poker.commun;

import java.io.Serializable;
import java.util.*;

// Classe de dfinition d'une carte  jouer parmi 
//    un jeu classique de 52 cartes dont l'As est la carte la plus haute
//
public class Carte implements Serializable, Comparable<Carte> {
	private static final long serialVersionUID = 1L;
	
	// Couleur d'une carte
	public final static String TREFLE   = "Trefle";
	public final static String CARREAU  = "Carreau";
	public final static String COEUR    = "Coeur";
	public final static String PIQUE    = "PIQUE";
	
	// Valeur d'une carte
	public final static String VALET    = "Valet";
	public final static String DAME     = "Dame";
	public final static String ROI      = "Roi";
	public final static String AS       = "As";
	// Les autres valeurs sont galement des String : "2 "3" .... "10"
	
	private String couleur;    // Couleur de la carte (Trefle, Carreau, Coeur, Pique)
	private String valeur;     // Valeur de la carte
	private int rang;          // Rang de la carte. Plus le rang est fort plus la carte est forte
	                           // As=13  Roi=12 ....  2=1
	private String image;      // image de la carte afin de l'afficher
	
	
	// Constructeur de la carte en fonction de sa Couleur et sa Valeur
	//
	public Carte(String couleur, String valeur) {
		super();
		this.couleur = couleur;
		this.valeur = valeur;
		String c="";
		String v="";
		if(couleur==Carte.TREFLE) c="c";
		if(couleur==Carte.CARREAU) c="d";
		if(couleur==Carte.COEUR) c="h";
		if(couleur==Carte.PIQUE) c="s";
		if(valeur==Carte.VALET) {v="j";rang=10;}
		else if(valeur==Carte.DAME) {v="q";rang=11;}
		else if(valeur==Carte.ROI) {v="k";rang=12;}
		else if(valeur==Carte.AS) {v="1";rang=13;}
		else {v=valeur;rang=Integer.parseInt(v)-1;}
		image="images/cards_gif/"+c+v+".gif";
	}
	
	
	
	
	public String getCouleur() {
		return couleur;
	}
	public void setCouleur(String couleur) {
		this.couleur = couleur;
	}
	public String getValeur() {
		return valeur;
	}
	public void setValeur(String valeur) {
		this.valeur = valeur;
	}
	public String getImage() {
		return image;
	}
	
	public int compareTo(Carte c) {
		if (this.getRang()==c.getRang()) return 0;
		if (this.getRang()<c.getRang()) return -1;
		else return 1;
	}
	
	public int getRang() {
		return rang;
	}
	
	public String toString() {
		return valeur+" "+couleur;
	}
	
}
