package fr.cnam.poker.commun;

import java.io.Serializable;
import java.util.ArrayList;

// Classe de dfinition de la requte de la ralisation d'une action par le joueur dans l'IHM.
//  Cette requte est envoye par la vue (IHM Poker) au serveur de Poker.
//
public class RequeteAction implements Serializable {
	private static final long serialVersionUID = 1L;
	
	// Les informations transmises dans la requte :
	//
	private int numeroJoueur;      // Le numro du joueur qui a ralis l'action
	private String nomAction;      // Le nom de l'action
	private String[] parametres;   // Les paramtres ventuels de l'action
	
	public RequeteAction(int numeroJoueur, String nomAction, String... parametres) {
		super();
		this.numeroJoueur = numeroJoueur;
		this.nomAction = nomAction;
		this.parametres = parametres;
	}

	public int getNumeroJoueur() {
		return numeroJoueur;
	}

	public String getNomAction() {
		return nomAction;
	}

	public String[] getParametres() {
		return parametres;
	}
	
	
}
