package fr.cnam.poker.commun;

import java.io.Serializable;
import java.util.ArrayList;

// Class de dfinition de la table de poker
//   Cet objet est utilis par la classe ModeleJeuPoker
//   Le modle est constitu de cet objet.
//   C'est cet objet qui est notifi aux vues (IHM de poker) systmatiquement suite  l'action d'un joueur.
//   
public class TablePoker implements Serializable {
	private static final long serialVersionUID = 1L;
	
	
	private ArrayList<Joueur>  joueurs;             // Tableau des joueurs
	private int                numeroJoueurCourant; // Numro du joueur de 0  N-1
	private int                blind;               // Valeur courante de la blind
	private boolean            commence;            // Le jeu a commnc
	private Carte              flop[];              // Les cartes du flop
	private Carte              turn;                // La carte du turn
	private Carte              river;               // La carte du turn
	private String             infos;               // Informations communes  tous les joueurs

	public TablePoker() {
		joueurs=new ArrayList<Joueur>();
		numeroJoueurCourant=0;
		blind=5;
		commence=false;
		flop=new Carte[3];
		infos="";
	}
	
	// Ajouter un nouveau joueur  la table de poker
	//  Retourne le numro du joueur (de 0  N) = indice dans le tableau de joueur
	//
	public int addJoueur(Joueur joueur) {
		if (joueurs.size()==4) return -1;
		joueurs.add(joueur);
		int indice = joueurs.size();
		joueur.setNumero(joueurs.size()-1);
		return  indice;
	}
	
	// Ajouter une information
	//
	public void addInfo(String info) {
		infos=info+"\n"+infos;
	}
	
	public boolean auMoinsUnRobot() {
		for(Joueur j:joueurs)if (j.isRobot()) return true;
		return false;
	}

	
	public String getInfos() {
		return infos;
	}

	public ArrayList<Joueur> getJoueurs() {
		return joueurs;
	}

	public Joueur getJoueur(int indice) {
		return joueurs.get(indice);
	}

	public int getNbJoueur() {
		return joueurs.size();
	}

	public int getNumeroJoueurCourant() {
		return numeroJoueurCourant;
	}

	public void setNumeroJoueurCourant(int numeroJoueurCourant) {
		this.numeroJoueurCourant = numeroJoueurCourant;
	}

	public int getBlind() {
		return blind;
	}

	public void setBlind(int blind) {
		this.blind = blind;
	}

	public boolean isCommence() {
		return commence;
	}

	public void setCommence(boolean commence) {
		this.commence = commence;
	}

	public Carte[] getFlop() {
		return flop;
	}

	public void setFlop(Carte[] flop) {
		this.flop = flop;
	}

	public Carte getTurn() {
		return turn;
	}

	public void setTurn(Carte turn) {
		this.turn = turn;
	}

	public Carte getRiver() {
		return river;
	}

	public void setRiver(Carte river) {
		this.river = river;
	}
}
