package fr.cnam.poker.robot;

import java.util.ArrayList;

import fr.cnam.poker.commun.Joueur;

// Classe de dfinition du Factory de robot qui permet de crer un robot
//
// Ce Factory est un SINGLETON
//
// Un robot est associ  un Joueur du Jeu de Poker.
//
public class FactoryRobot {
	public static FactoryRobot singleton=null;
	public static FactoryRobot getInstance() {
		if (singleton==null) singleton=new FactoryRobot();
		return singleton;
	}
	
	private ArrayList<Robot> robots;  // Les robots crs
	
	// Constructeur
	//
	private FactoryRobot() {
		robots=new ArrayList<Robot>();
	}
	
	// Retourne la cration d'un robot
	// Le robot cr est associ  un joueur de la table de poker.
	// Il "remplace" le joueur qui est pass en paramtre.
	//  
	//
	public Robot getRobot(Joueur joueur) {
		// Si le robot associ  ce joueur est dj cr alors il est retourn
		for(Robot rob:robots)
			if (rob.getJoueur().getNumero()==joueur.getNumero()) return rob;
		
		// Sinon on cre le robot associ au joueur
		RobotImpl robot = new RobotImpl(joueur);
		robots.add(robot);
		return robot;
	}
}
