package fr.cnam.poker.serveur;

import java.util.Observable;

// Classe de dfinition de l'Observer cr sur le serveur pour chacune des IHM qui se sont abonnes.
// Cet oberver a t cr quand une IHM s'est abonne en lui donnant sont host et son port.
// Le rle de cet observer est d'envoyer l'objet notifi (arg) dans une requte vers le host/port
import java.util.Observer;

import fr.cnam.poker.commun.RequeteNotification;

// Classe de dfinition de l'observer d'une IHM
//  Cet observer est un objet cr sur le serveur pour chacune des IHMs qui se sont aboones.
//  Le rle de cet Oberver est d'envoyer la requte de notification: envoyer arg  chacune des IHM
//
@SuppressWarnings("deprecation")
public class ObserverPokerIHM implements Observer {

	private String hostIHMPoker;  // host   de l'IHM associe  cet Oberver
	private int portIHMPoker;     // port   de l'IHM associe  cet Oberver


	// Constructeur
	//
	public ObserverPokerIHM(String hostIHMPoker, int portIHMPoker) {
		super();
		this.hostIHMPoker = hostIHMPoker;
		this.portIHMPoker = portIHMPoker;
	}

	// Mthode qui s'excute quand l'observer est notifi par l'Observable
	// Il s'agit d'envoyer l'objet notifi  l'IHM associe
	//
	@Override
	public void update(Observable o, Object arg) {
		// Envoi de la requete de l'objet a notifier
		//
		RequeteNotification req = new RequeteNotification(arg);
		ModeleJeuPoker.getInstance().envoyerRequete(hostIHMPoker,portIHMPoker,req);
	}

}
